function params = paramCheck(params)
% function paramCheck(params)
% E Thrane.  Checks the params struct for self-consistency and completeness.
  
  % check that the interferometer pair has been defined
  try
    params.ifo1;
    params.ifo2;
  catch
    error('Please specify params.ifo1 and params.ifo2');
  end

  % check that the freqency range has been specified
  try
    params.fmin;
    params.fmax;
  catch
    error('Please specify the frequency range: params.fmin and params.fmax');
  end
  
  % check that the search direction has been supplied
  try
    if params.ra<0|params.ra>=24
      error('params.ra must be between 0 and 24.');
    end
    if params.dec<-90|params.dec>90
      error('params.dec must be between -90 and +90.');
    end
  catch
    error('Please specify the search direction: params.ra and params.dec');
  end

  % check that all other params values have been set
  try
    params.doStampFreqMask;
    params.StampFreqsToRemove;
    params.StampnBinsToRemove;
    params.coarsegrained;
    params.G;
    params.c;
    params.ErgsPerSqCM;
    params.yMapScale;
    params.FMapScale;
    params.fluence;
    params.glitchCut;
    params.phaseScramble;
    params.pixelScramble;
    params.fixAntennaFactors;
    params.saveMat;
    params.savePlots;
    params.debug;
    params.recordCuts;
    params.doMC;
    params.doRadon;
    params.doRadonReconstruction;
    params.doPolar;
    params.purePlus;
    params.pureCross;
    params.doBoxSearch;
    params.doLH=false;
    params.doRadiometer;
    params.doClusterSearch;
    params.Autopower;
    params.NoTimeDelay;
    params.skypatch;
    params.frompreproc;
    params.stamp_pem;
  catch
    fprintf('Are you using stampDefaults?\n');
    error('There are default fields missing from the params struct.');
  end

% make sure clustering algorithm has everything it needs
if params.doClusterSearch
  try
    params.cluster.doCombineCluster; % cluster the clusters
    params.cluster.NN; % minimum number of neighbours
    params.cluster.NR; % neighbor radius as determined by metric
    params.cluster.NCN; % minimum number of pixels in a cluster
    params.cluster.NCR; % distance between neighbouring clusters
    params.cluster.pixelThreshold;
    params.cluster.tmetric;
    params.cluster.fmetric;
  catch
    error('You are missing clustering parameters. Please see clusterDefaluts.')
  end
  % check if parameters are sensibly defined
  if params.cluster.NCN <= params.cluster.NN
    warning('Typically NCN>NN so that superclusters are bigger than clusters.');
  end
  if params.cluster.NCR <= params.cluster.NR
    warning('Typically NCR>NR so that superclusters are bigger than clusters.');
  end
end

% make sure thetamax and dtheta are defined for the skypatch option
if params.skypatch
  try
    params.thetamax;
    params.dtheta;
  catch
    error(['params.skypatch requires additional fields: params.thetamax ' ...
           'and params.dtheta.']);
  end
end

% check for mutally exclusive requests
if params.doPolar+params.purePlus+params.pureCross>1
  error('Mutually exclusive polarization requests.');
end

% make sure iota and psi are defined for the doPolar option
if params.doPolar
  warning('params.doPolar is not reviewed code.');
  if ~(isfield(params,'psi'))
    error('doPolar requires that params.iota and params.psi be set.');
  elseif params.psi>=2*pi
    error('psi must be in radians');
  end
  if ~(isfield(params,'iota'))
    error('doPolar requires that params.iota and params.psi be set.');
  elseif params.iota>pi
    error('iota must be in radians');
  end
end

% make sure that the box search has all the variables that it needs
if params.doBoxSearch
  if ~(isfield(params,'box'))
    error('doBoxSearch requires that params.box parameters be set.');
  end
  if ~(isfield(params.box,'freq_width'))
    error('doBoxSearch requires that params.box.freq_width be set.');
  elseif params.box.freq_width<=0
    error('params.box.freq_width must be > 0.');
  end
  if ~(isfield(params.box,'time_width'))
    error('doBoxSearch requires that params.box.time_width be set.');
  elseif params.box.time_width<=0
    error('params.box.time_width must be > 0.');
  end
  if ~(isfield(params.box,'debug'))
    error('doBoxSearch requires that params.box.debug be set.');
  end
end

% make sure DQ CAT categories are specified if DQ_cut is on
if (params.glitchCut == 7 || params.glitchCut == 8)
  if isempty(params.DQcut)
    error('DQ_cut requires that params.DQcut is set.');
  end
end

% make sure the glitch cuts have all the features turned on that they need
if (params.glitchCut == 5 || params.glitchCut == 6 || params.glitchCut == 8)
  if params.Autopower==false
    warning('Overriding params.Autopower for use in glitch cuts.');
    params.Autopower = true;
  end
end

% Most glitch cuts are for diagnostic purposes and are not appropriate for
% analysis purposes.  The vetted cuts are 5 and 11.  If any other cut is
% requested by the user, a warning message is generated by paramCheck.
if (params.glitchCut==5 || params.glitchCut==7 || params.glitchCut==8 || ...
   params.glitchCut==0)
  % do nothing
else
  warning(['You have chosen a value of glitchCut which may not be ' ...
           'suitable for analysis purposes.'])
end

% params.discontinuity is only used internally by addMissingDatatoMap
if params.discontinuity
  fprintf('Reset params.discontinuity; not an external variable.\n');
  params.discontinuity=false;
end

% need injection file to do an injection
if params.powerinj
  % injection time always the same (default is no)
  try
    params.fixedInjectionTime;
  catch
    params.fixedInjectionTime = false; 
  end
  % how many injections to perform - default is one.
  try
    params.alpha_n;
    % if alpha_n is specified, the user must specify a range of values
    try
      params.alpha_min;
      params.alpha_max;
    catch
      error('Specify params.alpha_min and alpha_max when alpha_n is defined.');
    end
  catch
    params.alpha_n=1;
  end
  % specify injection step size
  if params.alpha_n==1
    params.alpha_step=0;
  elseif params.alpha_n>1
    params.alpha_step=(params.alpha_max - params.alpha_min)/(params.alpha_n-1);
  else
    error('params.alpha_n must be >= 1.');
  end
  % make sure auto-power is on
  if ~params.Autopower
    warning('Overriding params.Autopower for use in powerinj.');
    params.Autopower = true;
  end
  % make sure injection file is defined
  try
    params.injfile;
  catch
    error('powerinj requires the definition of injfile.');
  end
end

if (params.glitchCut~=0 & params.glitchCut~=5 & params.glitchCut~=8) | ...
  params.phaseScramble | params.pixelScramble | params.fixAntennaFactors | ...
  params.NoTimeDelay | params.doMC | params.doPolar | params.purePlus | ...
  params.pureCross | params.stamp_pem | params.bkndstudy
  params.diagnostic=true;
else
  params.diagnostic=false;
end

return
